//-------------------------------------------------------

#define			OBJNAME_LABEL		"Alerter Label"
#define			OBJDESC_PATTERN		"Alert_"

#property indicator_chart_window

extern bool	  EmailAlert	= False;
extern bool   PopupAlert	= False;
extern double DrawDelay  = 4;
extern string Comment1="Delay in Seconds";
extern bool   AlertOnce = False;


    double Time1,Time2;

       int StartDraw;
       int EndDraw;
       int OldStartDraw,FirstDraw;
       int Counter;

//--------------------------------------------------------------------
//----
//--------------------------------------------------------------------
int init() 

   {
  	  createIndicatorLabel(OBJNAME_LABEL);
	
     //-----------------------------
     StartDraw = FirstVisibleBar();
     OldStartDraw = StartDraw;    
     Time1=TimeLocal();
     Time2=TimeLocal();  
     
   }

//--------------------------------------------------------------------
//----
//--------------------------------------------------------------------

int deinit() {
	ObjectDelete(OBJNAME_LABEL);
}


//--------------------------------------------------------------------
//----
//--------------------------------------------------------------------
int start() 

 {
   if(IsStopped()==true) return(0);
	
   //--------------------------------------
   bool   Draw=False;
   double FinishTime=TimeLocal();    
   if (DrawDelay<5) DrawDelay=5;
   //--------------------------------------                                               
   if ((FinishTime - Time1) >= DrawDelay )
    {       
           FinishTime=TimeLocal();
           Time1=TimeLocal();
           Draw=True;      
    }     
      
   //-----------------------------------
   StartDraw = FirstVisibleBar();
   EndDraw = FirstVisibleBar()-BarsPerWindow();
   if (StartDraw<80) StartDraw=80; 
   if (EndDraw<0) EndDraw=0;     
   //-----------------------------------
   if ((StartDraw!=OldStartDraw) || Draw==True )
   {   
     OldStartDraw = StartDraw;

    for (int i=ObjectsTotal()-1;i>=0;i--) 
	
	 {
		string	sObjName 	= ObjectName(i);
		double	dObjPrice;
		double		iObjAlert=0.00001;
		double		iProximity=0.00001;
		string	sMessage;
	
		// Can we get a price for this object?  If not, continue iteration
      dObjPrice = -1;
	   int iObjType = ObjectType(sObjName);
	
	   if (iObjType == OBJ_HLINE) dObjPrice = ObjectGet(sObjName,OBJPROP_PRICE1);
	   if (iObjType == OBJ_TREND) dObjPrice = ObjectGetValueByShift(sObjName,0);
	   
	   if (dObjPrice == -1) continue;
		
		// Is there an alert on this object?  If not, continue iteration
		iObjAlert = getObjectAlert(sObjName);
		
		// Is the line within alert proximity?  If not, continue iteration
		double TempBid=Bid;
		iProximity = MathAbs(TempBid - dObjPrice)/Point;
      if (Point!=0.0001) iProximity=iProximity*0.1;
		if (iProximity > iObjAlert) continue;

   	PlaySound("electricalcurrent2.wav");

		// Fire the alert and clear alert from description
		
		if (Point==0.0001)
		{
		sMessage = "Alert triggered: " + Symbol() + "@" + DoubleToStr(Bid,Digits)  +"."
			+ "  " + (iProximity) + " pips from " + sObjName + ".";
		}			
		else
		{
		sMessage = "Alert triggered: " + Symbol() + "@" + DoubleToStr(Bid,Digits)  +"."
			+ "  " + (iProximity*0.1) + " pips from " + sObjName + ".";
		}	
			
		if (PopupAlert) Alert(sMessage);
		if (EmailAlert) SendMail("Email Alert - " + Symbol(), sMessage);
		
		// Clear the alert from the object description
		if (AlertOnce==True) clearObjectAlert(sObjName);
	
	}
	
	} //end StartDraw
	

	return(0);
}




int getObjectAlert(string sObjName) {

	// looking for pattern "alert_##" at end of obj description
	string 	sObjectDesc		= ObjectDescription(sObjName);
	int 	iPatternOffset 	= StringFind(sObjectDesc,OBJDESC_PATTERN);
	int		iPatternLength	= StringLen(OBJDESC_PATTERN);

	// if pattern not found, no alert for this object
	if (iPatternOffset == -1) 
		return(-1);
	
	// return value after the pattern as number
	return(StrToInteger(StringSubstr(sObjectDesc,iPatternOffset+iPatternLength)));
}

void clearObjectAlert(string sObjName) {

	// strip "Alert_" from end of obj description
	string 	sObjDesc 		= ObjectDescription(sObjName);
	int 	iSubStrOffset 	= StringFind(sObjDesc,"Alert_");
	
	// if found at start of description, clear description
	if (iSubStrOffset == 0) {
		ObjectSetText(sObjName,"");
		return;
	}
	
	// if found further on in desc, strip it from description
	if (iSubStrOffset > 0) {
		ObjectSetText(sObjName,StringSubstr(sObjDesc,0,iSubStrOffset));
		return;
	}
}

void createIndicatorLabel(string sObjName) {
	
	// Set the text
	string sObjText = "Alerter:";
	if (EmailAlert) sObjText = sObjText + "  Emails Alerts ON.";
	else            sObjText = sObjText + "  Emails Alerts OFF.";
	if (PopupAlert) sObjText = sObjText + "  Popup Alerts ON.";
	else			sObjText = sObjText + "  Popup Alerts OFF.";
	
	// Create and position the label
	ObjectCreate(sObjName,OBJ_LABEL,0,0,0);
	ObjectSetText(sObjName,sObjText,8,"Arial",Gold);
	ObjectSet(sObjName,OBJPROP_XDISTANCE,5);
	ObjectSet(sObjName,OBJPROP_YDISTANCE,10);
	ObjectSet(sObjName,OBJPROP_CORNER,1);
	
}
	

